<?php
/*------------------------------------------------------------------------
# helper.php - mod_ospropertyrandom1
# ------------------------------------------------------------------------
# author    Dang Thuc Dam
# copyright Copyright (C) 2010 joomdonation.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomdonation.com
# Technical Support:  Forum - http://www.joomdonation.com/forum.html
*/
/** ensure this file is being included by a parent file */
defined('_JEXEC') or die('Restricted access');
jimport( 'joomla.application.component.model' );

class modOSpropertyShowCaseHelper extends JObject
{
	/**
     * Sets the modules params as a property of the object
     * @param unknown_type $params
     * @return unknown_type
     */
	function __construct( $params )
	{
		$this->params = $params;
	}

	/**
     * Sample use of the products model for getting products with certain properties
     * See admin/models/products.php for all the filters currently built into the model 
     * 
     * @param $parameters
     * @return unknown_type
     */
	function getProperty()
	{
		define('DS',DIRECTORY_SEPARATOR);
		$db = JFactory::getDBO();
		$check_search = true;

		// number property is shown
		$number_property = $this->params->get('number_property', 5);

		// filter property for lastest
		$filter_latest = $this->params->get('latest',0);

		// filter property for category
		$filter_category = $this->params->get('category',0);

		// filter property for type
		$filter_type = $this->params->get('type',0);

		$style = $this->params->get('mstyle',0);

		$featured = $this->params->get('featured',0);

		// condition
		$where = array();
		$where[] = 'published = 1';
		$where[] = 'approved = 1';

		if ($filter_category > 0){
			$categoryArr = array();
			$categoryArr = HelperOspropertyCommon::getSubCategories($filter_category,$categoryArr);
			$catids      = implode(",",$categoryArr);
			$where[]     = " category_id IN ($catids) ";
			//$check_search = false;
		}

		if ($filter_type > 0){
			$where[] = "pro_type = $filter_type";
			//$check_search = false;
		}

		if($featured == 1){
			$where[] = "isFeatured = '1'";
		}else{
			$where[] = "isFeatured = '0'";
		}

		$where 		= ( count( $where ) ? ' WHERE ('. implode( ') AND (', $where ).')' : '' );

		//if ($filter_latest || ($filter_category == '' && $filter_type == '')){
		//$order_by_latest = ' ORDER BY created DESC';
		//$limit_latest = " LIMIT 0 , ".($number_property + 5);
		////$select_limit = "SELECT id FROM #__osrs_properties $where $order_by_latest $limit_latest";
		//$db->setQuery($select_limit);
		//$where = " WHERE id IN (".implode(',',$db->loadResultArray()).")";
		//$check_search = false;
		//}

		//if ($check_search){
		//	return array(array(),$check_search);
		//}

		//$select_limit = "SELECT id FROM #__osrs_properties ";
		//$order_by = " ORDER BY RAND() ";
		//$limit = " LIMIT 0, $number_property";
		//$db->setQuery($select_limit.$where.$order_by.$limit);
		//$where = " WHERE p.id IN (".implode(',',$db->loadResultArray()).")";

		// get property have been filter
		$select = "	SELECT p.*, s.state_name, c.country_name,ca.id as catid, ca.category_name, ty.id as typeid, ty.type_name  FROM #__osrs_properties AS p
    				INNER JOIN #__osrs_categories AS ca ON ca.id = p.category_id
    				INNER JOIN #__osrs_types AS ty ON ty.id = p.pro_type
    				INNER JOIN #__osrs_states AS s ON s.id = p.state
    				INNER JOIN #__osrs_countries AS c ON c.id = p.country
    				INNER JOIN #__osrs_agents as ag ON p.agent_id = ag.id
    				";
		$where = " WHERE p.published = '1' AND p.approved = '1'";
		if($featured == 1){
			$where .= " AND p.isFeatured = '1'";
		}
		if($filter_category > 0){
			$categoryArr = array();
			$categoryArr = HelperOspropertyCommon::getSubCategories($filter_category,$categoryArr);
			$catids      = implode(",",$categoryArr);
			$where      .= " AND p.category_id IN ($catids)";
		}
		if($filter_type > 0){
			$where .= " AND p.pro_type = '$filter_type'";
		}

		if($filter_latest == 1){
			$order_by = " ORDER BY p.created DESC";
		}else{
			$order_by = " ORDER BY rand() DESC";
		}

		$limit = " limit $number_property";

		$db->setQuery($select.$where.$order_by.$limit);
		//echo $db->getQuery();
		$properties = $db->loadObjectList();

		foreach (@$properties as $property) {
			$db->setQuery("SELECT image FROM #__osrs_photos WHERE pro_id = $property->id order by ordering");
			$property->photo = $db->loadResult();
		}

		//return array($properties,$check_search);
		return $properties;
	}
}
?>
